using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Threading;

namespace CsFileCopy
{
    /// <summary>
    /// t@CõCxgnh
    /// </summary>
    /// <param name="sender">Cxg𔭐IuWFNg</param>
    /// <param name="e">Cxg</param>
    public delegate void FileRetrieveEventHandler(object sender, FileRetrieveEventArgs e);

    /// <summary>
    /// t@CõCxgNX
    /// </summary>
    public class FileRetrieveEventArgs : EventArgs
    {
        /// <summary>
        /// t@C
        /// </summary>
        public string FileName
        {
            get;
            set;
        }

        /// <summary>
        /// t@CXgɒǉ邩ǂ
        /// </summary>
        public bool AddToFile
        {
            get;
            set;
        }

        /// <summary>
        /// Ώۂ̃tH_
        /// </summary>
        public string SearchFolder
        {
            get;
            set;
        }
    }

	/// <summary>
	/// t@CoNX
	/// </summary>
	public class FileRetriever
	{
        /// <summary>
        /// t@CƂ̃Cxg
        /// </summary>
        public event FileRetrieveEventHandler FileFound;

        /// <summary>
        /// t@CXgɒǉƂ̃Cxg
        /// </summary>
        public event FileRetrieveEventHandler AddingFileToList;

        /// <summary>
        /// ΏۃtH_ύXꂽƂ̃Cxg
        /// </summary>
        public event FileRetrieveEventHandler SearchFolderChanged;

        /// <summary>
        /// Oo̓NX
        /// </summary>
        public ILog Log
        {
            get;
            set;
        }

        /// <summary>
        /// t@CoNX܂B
        /// </summary>
		public FileRetriever()
		{
		}

		/// <summary>
		/// w肳ꂽtH_ɂ邷ׂẴt@C擾
		/// </summary>
		/// <param name="folder">t@CtH_B</param>
		/// <param name="searchPattern">t@CBChJ[hwq(*, ?)gpB</param>
		/// <param name="files">t@C̃Xg</param>
		public void GetAllFilesInDirectory(
            string folder, string searchPattern, ref List<string> fileList)
		{
            FileRetrieveEventArgs folderChangeEvent = new FileRetrieveEventArgs();
            folderChangeEvent.SearchFolder = folder;

            // Cxgs
            if (SearchFolderChanged != null)
            {
                SearchFolderChanged(this, folderChangeEvent);
            }

            try
            {
                // folderɂt@C擾
                string[] files =
                    System.IO.Directory.GetFiles(folder, searchPattern);

                foreach (string file in files)
                {
                    FileRetrieveEventArgs fileFoundEvent = new FileRetrieveEventArgs();
                    fileFoundEvent.FileName = file;

                    // Cxgs
                    if (FileFound != null)
                    {
                        FileFound(this, fileFoundEvent);
                    }

                    FileRetrieveEventArgs addingFileEvent = new FileRetrieveEventArgs();
                    addingFileEvent.FileName = file;

                    // Cxgs
                    if (AddingFileToList != null)
                    {
                        AddingFileToList(this, addingFileEvent);
                    }

                    // t@CXgɒǉꍇ
                    if (addingFileEvent.AddToFile)
                    {
                        // Xgɒǉ
                        fileList.Add(file);
                    }
                }
            }
            catch (Exception e)
            {
                if (Log != null)
                {
                    Log.Error(e.Message);
                }
            }
		}

		/// <summary>
		/// w肳ꂽtH_ȉɂ邷ׂẴt@C擾
		/// </summary>
		/// <param name="folder">t@CtH_B</param>
		/// <param name="searchPattern">t@CBChJ[hwq(*, ?)gpB</param>
		/// <param name="files">t@C̃Xg</param>
		public void GetAllFilesRecursive(
            string folder, string searchPattern, ref List<string> fileList)
		{
            FileRetrieveEventArgs folderChangedEvent = new FileRetrieveEventArgs();
            folderChangedEvent.SearchFolder = folder;

            // Cxgs
            if (SearchFolderChanged != null)
            {
                SearchFolderChanged(this, folderChangedEvent);
            }

            try
            {
                // folderɂt@C擾
                string[] files =
                    System.IO.Directory.GetFiles(folder, searchPattern);

                foreach (string file in files)
                {
                    FileRetrieveEventArgs fileFoundEvent = new FileRetrieveEventArgs();
                    fileFoundEvent.FileName = file;

                    // Cxgs
                    if (FileFound != null)
                    {
                        FileFound(this, fileFoundEvent);
                    }

                    FileRetrieveEventArgs addingFileEvent = new FileRetrieveEventArgs();
                    addingFileEvent.FileName = file;

                    // Cxgs
                    if (AddingFileToList != null)
                    {
                        AddingFileToList(this, addingFileEvent);
                    }

                    // t@CXgɒǉꍇ
                    if (addingFileEvent.AddToFile)
                    {
                        // Xgɒǉ
                        fileList.Add(file);
                    }
                }
            }
            catch (Exception e)
            {
                if (Log != null)
                {
                    Log.Error(e.Message);
                }
            }

            Application.DoEvents();

            try
            {
                // folder̃TutH_擾
                string[] directories = System.IO.Directory.GetDirectories(folder);

                // TutH_ɂt@Cׂ
                foreach (string d in directories)
                {
                    GetAllFilesRecursive(d, searchPattern, ref fileList);
                }
            }
            catch (Exception e)
            {
                if (Log != null)
                {
                    Log.Error(e.Message);
                }
            }
		}
	}
}
